//   2,5   5-6     
//  -  
// email: yurakis2004@mail.ru
unit UnDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin;

type
  TFormDemo = class(TForm)
    PanPaint: TPanel;
    PBPaint: TPaintBox;
    Label1: TLabel;
    SEWidth: TSpinEdit;
    Label2: TLabel;
    BClear: TButton;
    GroupBox1: TGroupBox;
    BChars: TButton;
    BNumeric: TButton;
    BFont: TButton;
    LFont: TLabel;
    FD: TFontDialog;
    Panel1: TPanel;
    PB16x16: TPaintBox;
    LBResult: TListBox;
    BAnalyze: TButton;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PBPaintPaint(Sender: TObject);
    procedure PBPaintMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PBPaintMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PBPaintMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BClearClick(Sender: TObject);
    procedure BCharsClick(Sender: TObject);
    procedure BFontClick(Sender: TObject);
    procedure BNumericClick(Sender: TObject);
    procedure BAnalyzeClick(Sender: TObject);
  private
    Img : TBitmap;                    //      
  public
  end;

var
  FormDemo: TFormDemo;

implementation

{$R *.dfm}

uses Math;

type
  TMas16x16 = array [0..15] of array [0..15] of byte;  //   ()  16x16

var
  MasSimple16 : array of TMas16x16;                    //  


//==========     ===========================
  
function Create_16x16(Img : TBitmap) : TMas16x16;
type
  MasX = PByteArray;
var
  MasY : array of MasX;                             //      (Y x X)
  j, i : integer;
  xLeft, xRight, yTop, yBottom : integer;           // . . 
  ki, kj : integer;
  nSymbol : integer;                                // -  
  Percent : double;                                 //  
  XY : array [0..16] of record x, y : integer end;  //    
  W, H : integer;                                   //    

begin
  SetLength(MasY, Img.Height);                      //    
  for j := 0 to Img.Height - 1 do                   //     
    MasY[j] := Img.ScanLine[j];                     // MasY[y - ][x - ] = .  (x,y)

  //--------     ---------------------------------
  //       MasY[y][x] = 0    


  xLeft := -1;                                      // 
  xRight := -1;
  yTop := -1;
  yBottom := -1;

  for j := 0 to Img.Height - 1 do                   // Top
  begin
    for i := 0 to Img.Width - 1 do
      if MasY[j][i] = 0 then
      begin yTop := j; break; end;
    if yTop = j then break;
  end;

  for j := Img.Height - 1 downto 0 do               // Bottom
  begin
    for i := 0 to Img.Width - 1 do
      if MasY[j][i] = 0 then
      begin yBottom := j + 1; break; end;
    if yBottom = j + 1 then break;
  end;

  for i := 0 to Img.Width - 1 do                    // Left
  begin
    for j := 0 to Img.Height - 1 do
      if MasY[j][i] = 0 then begin xLeft := i; break; end;
    if xLeft = i then break;
  end;

  for i := Img.Width - 1 downto 0 do                // Right
  begin
    for j := 0 to Img.Height - 1 do
      if MasY[j][i] = 0 then begin xRight := i + 1; break; end;
    if xRight = i + 1 then break;
  end;

  //----------------------------------------------------------------------------

  if ((yBottom - yTop)*(xRight - xLeft)) = 0 then   //    
  begin
    exit;
  end;

  //----------------------------------------------------------------------------
  //      -    
  // -    
  // Percent          1616 
  nSymbol := 0;
  for j := yTop to yBottom do
  for i := xLeft to xRight do
    if MasY[j][i] = 0 then inc(nSymbol);
  Percent := nSymbol / ((yBottom - yTop)*(xRight - xLeft));
  Percent := 0.99*Percent;     // -     1616
                               // > 1 -    
                               // < 1 -    
  //----------------------------------------------------------------------------


  //----------------------------------------------------------------------------
  //     16       2
  //      

  W := xRight - xLeft;;
  XY[0].x  := 0;
  XY[16].x := W;
  XY[8].x  :=   XY[16].x div 2;
  XY[4].x  :=   XY[8].x div 2;
  XY[2].x  :=   XY[4].x div 2;
  XY[1].x  :=   XY[2].x div 2;
  XY[3].x  :=  (XY[4].x + XY[2].x) div 2;
  XY[6].x  :=  (XY[8].x + XY[4].x) div 2;
  XY[5].x  :=  (XY[6].x + XY[4].x) div 2;
  XY[7].x  :=  (XY[8].x + XY[6].x) div 2;
  XY[12].x :=  (XY[16].x + XY[8].x) div 2;
  XY[10].x :=  (XY[12].x + XY[8].x) div 2;
  XY[14].x :=  (XY[16].x + XY[12].x) div 2;
  XY[9].x  :=  (XY[10].x + XY[8].x) div 2;
  XY[11].x :=  (XY[12].x + XY[10].x) div 2;
  XY[13].x :=  (XY[14].x + XY[12].x) div 2;
  XY[15].x :=  (XY[16].x + XY[14].x) div 2;
  H := yBottom - yTop;
  XY[0].y  := 0;
  XY[16].y := H;
  XY[8].y  :=   XY[16].y div 2;
  XY[4].y  :=   XY[8].y div 2;
  XY[2].y  :=   XY[4].y div 2;
  XY[1].y  :=   XY[2].y div 2;
  XY[3].y  :=  (XY[4].y + XY[2].y) div 2;
  XY[6].y  :=  (XY[8].y + XY[4].y) div 2;
  XY[5].y  :=  (XY[6].y + XY[4].y) div 2;
  XY[7].y  :=  (XY[8].y + XY[6].y) div 2;
  XY[12].y :=  (XY[16].y + XY[8].y) div 2;
  XY[10].y :=  (XY[12].y + XY[8].y) div 2;
  XY[14].y :=  (XY[16].y + XY[12].y) div 2;
  XY[9].y  :=  (XY[10].y + XY[8].y) div 2;
  XY[11].y :=  (XY[12].y + XY[10].y) div 2;
  XY[13].y :=  (XY[14].y + XY[12].y) div 2;
  XY[15].y :=  (XY[16].y + XY[14].y) div 2;
  //----------------------------------------------------------------------------


  //----------------------------------------------------------------------------
  //        
  //     16x16

  for kj := 0 to 15 do
  for ki := 0 to 15 do
  begin
    nSymbol := 0;
    for j := yTop + XY[kj].y to yTop + XY[kj+1].y do    //    
    for i := xLeft + XY[ki].x to xLeft + XY[ki+1].x do  //   
      if MasY[j][i] = 0 then inc(nSymbol);              //  -   (=0 ->  )
    //   - .    -   >     = 1  = 0
    if nSymbol / MAX(1, ((XY[ki+1].x - XY[ki].x) * (XY[kj+1].y - XY[kj].y))) > Percent
      then Result[kj][ki] := 1 else Result[kj][ki] := 0; //  -   1616
  end;
  SetLength(MasY, 0); //   ...
end;

//==============================================================================

procedure TFormDemo.FormCreate(Sender: TObject);
begin
  Img := TBitmap.Create;             //  
  Img.PixelFormat := pf8bit;         //    - 1   
  Img.Width := 200;                  // 
  Img.Height := 200;                 // - // -
  PanPaint.DoubleBuffered := true;   //        PaintBox
  LFont.Caption := 'Name: ' + FD.Font.Name + #13#10 +    //    
                   'Size: ' + inttostr(FD.Font.Size);
end;

procedure TFormDemo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Img.Free;                          //    ...
  SetLength(MasSimple16, 0);         //  
end;

procedure TFormDemo.PBPaintPaint(Sender: TObject);
begin
  PBPaint.Canvas.Draw(0, 0, Img);    //  
end;

var
  msX, msY : integer;                //    
  msDown   : boolean;                //  

procedure TFormDemo.PBPaintMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  msDown := true;                   //   
  msX    := X;                      // ...   
  msY    := Y;                      //
  Img.Canvas.Pen.Width := SEWidth.Value; //   
end;

procedure TFormDemo.PBPaintMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if msDown then                    //     ...
  with Img.Canvas do
  begin
    MoveTo(msX, msY);               //   
    LineTo(X, Y);                   // 
    msX := X;                       //  
    msY := Y;                       //
  end;
  PBPaint.Repaint;                  // 
end;

procedure TFormDemo.PBPaintMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  msDown := false;                  //   
end;

procedure TFormDemo.BClearClick(Sender: TObject);
begin
  with Img.Canvas do                //   
  begin
    Brush.Color := clWhite;
    Pen.Color := Brush.Color;
    Rectangle(0,0,Img.Width,Img.Height);
    Pen.Color := clBlack;           //  
  end;
  PBPaint.Repaint;
end;

procedure TFormDemo.BFontClick(Sender: TObject);
begin
  if FD.Execute then LFont.Caption := 'Name: ' + FD.Font.Name + #13#10 +
                   'Size: ' + inttostr(FD.Font.Size);      
end;

var
  iSymbol : integer;      //    
                          //    1 - , 2 - 

procedure TFormDemo.BCharsClick(Sender: TObject);
var
  i : integer;
begin
  iSymbol := 1;
  SetLength(MasSimple16, 32*SizeOf(TMas16x16));     //        
  for i := 0 to 31 do
  with Img.Canvas do
  begin
    Brush.Color := clWhite;                         // ...
    Pen.Color := clWhite;
    Rectangle(0,0,Img.Width,Img.Height);
    Pen.Color := clBlack;
    Font.Color := clBlack;
    Font.Size := FD.Font.Size;
    Font.Style := FD.Font.Style;
    Font.Name := FD.Font.Name;
    Img.Canvas.TextOut(10, 10, CHR(ORD('')+i));   // 
    MasSimple16[i] := Create_16x16(Img);           //    i- 
  end;
  BClear.Click;                                    // 
  MessageBox(handle, '  .       "".', '!', MB_OK or MB_ICONInformation);
end;

procedure TFormDemo.BNumericClick(Sender: TObject);
var
  i : integer;
begin
  iSymbol := 2;
  SetLength(MasSimple16, 10*SizeOf(TMas16x16));    //      0  9,  ...
  for i := 0 to 9 do
  with Img.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clWhite;
    Rectangle(0,0,Img.Width,Img.Height);
    Pen.Color := clBlack;
    Font.Color := clBlack;
    Font.Size := FD.Font.Size;
    Font.Style := FD.Font.Style;
    Font.Name := FD.Font.Name;
    Img.Canvas.TextOut(10, 10, CHR(ORD('0')+i));
    MasSimple16[i] := Create_16x16(Img);
  end;
  BClear.Click;
  MessageBox(handle, '  .       "".', '!', MB_OK or MB_ICONInformation);
end;

procedure TFormDemo.BAnalyzeClick(Sender: TObject);
var
  k,i,j, ki, kj : integer;
  Mas,                            // 1616   
  MasChar : TMas16x16;            // 1616    
  Res : array [0..31] of byte;    //  ""   
  nMax : integer;
  iMin : integer;
begin
  if Length(MasSimple16) = 0 then    //  ...
  begin
    MessageBox(handle, '    !', '!', MB_OK or MB_ICONWARNING);
    exit;
  end;

  MasChar := Create_16x16(Img);    //  1616    

  PB16x16.Repaint;                 //  

  with PB16x16.Canvas do           //    ( ...)
  for kj := 0 to 15 do
  for ki := 0 to 15 do
  begin
    Brush.Color := clRed;
    if MasChar[kj][ki] = 1 then Brush.Style := bsSolid else Brush.Style := bsClear;
    Rectangle(ki * 7, kj * 7, ki * 7 + 7, kj * 7 + 7);
  end;

  for k := 0 to 31 do              //  1616      
  begin                            // xor -     
    for j := 0 to 15 do            //    -  
    for i := 0 to 15 do
      Mas[j][i] := MasChar[j][i] xor MasSimple16[k][j][i];

    Res[k] := 0;
    for j := 0 to 15 do
    for i := 0 to 15 do
      Res[k] := Res[k] + Mas[j][i]; //   (- )   
  end;

  LBResult.Clear;
  if iSymbol = 1 then               //     -   
    for i := 0 to 31 do
    begin
      nMax := 255;
      iMin := 0;
      for k := 0 to 31 do
      if Res[k] < nMax then
      begin
        iMin := k;
        nMax := Res[k];
      end;
      //       (256 -  -   1616)
      LBResult.Items.Add(CHR(ORD('') + iMin) + '     ' + inttostr(round(100*(1 - Res[iMin] / 256)))+'%');
      Res[iMin] := 255;                     
    end
  else
  if iSymbol = 2 then             //   ...
    for i := 0 to 9 do
    begin
      nMax := 255;
      iMin := 0;
      for k := 0 to 9 do
      if Res[k] < nMax then
      begin
        iMin := k;
        nMax := Res[k];
      end;
      LBResult.Items.Add(CHR(ORD('0') + iMin) + '     ' + inttostr(round(100*(1 - Res[iMin] / 256)))+'%');
      Res[iMin] := 255;
    end;

end;

end.
